%global srcname fibers

Name:           guile-%{srcname}
Version:        1.3.1
Release:        1%{?dist}
Summary:        Concurrent ML-like concurrency for Guile

License:        GPLv2
URL:            https://github.com/wingo/fibers
Source0:        https://github.com/wingo/fibers/archive/refs/tags/v%{version}.tar.gz

BuildRequires:  /usr/bin/autoreconf /usr/bin/aclocal
BuildRequires:  libtool

%global _description %{expand:
Fibers is a facility that provides Go-like concurrency for Guile
Scheme, in the tradition of Concurrent ML.}

%description %_description


%package -n guile22-%{srcname}
Summary:        Concurrent ML-like concurrency for Guile
BuildRequires:  guile22-devel
Requires:       guile22
Recommends:     guile-%{srcname}-doc

%description -n guile22-%{srcname} %_description


%package -n guile30-%{srcname}
Summary:        Concurrent ML-like concurrency for Guile
BuildRequires:  guile30-devel
Requires:       guile30
Recommends:     guile-%{srcname}-doc

%description -n guile30-%{srcname} %_description


%package doc
Summary:        Documentation for guile-fibers
BuildRequires:  texinfo

%description doc %_description


%prep
%setup -qc
mv %{srcname}-%{version} guile22
cp -a guile22 guile30


%build
pushd guile22
./autogen.sh
%configure \
    GUILE_EFFECTIVE_VERSION=2.2 \
    GUILE=/usr/bin/guile2.2 \
    GUILD=/usr/bin/guild2.2 \
    GUILE_CONFIG=/usr/bin/guile-config2.2
%make_build
popd

pushd guile30
./autogen.sh
%configure \
    GUILE_EFFECTIVE_VERSION=3.0 \
    GUILE=/usr/bin/guile3.0 \
    GUILD=/usr/bin/guild3.0 \
    GUILE_CONFIG=/usr/bin/guile-config3.0
%make_build
popd


%install
rm -rf $RPM_BUILD_ROOT

pushd guile22
%make_install
popd

pushd guile30
%make_install
popd

find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'
rm -f $RPM_BUILD_ROOT%{_infodir}/dir


%files -n guile22-%{srcname}
%license guile22/COPYING guile22/COPYING.LESSER
%doc guile22/README.md guile22/NEWS guile22/ChangeLog guile22/HACKING guile22/AUTHORS guile22/TODO.md
%{_libdir}/guile/2.2/extensions/fibers-epoll.so*
%{_libdir}/guile/2.2/site-ccache/fibers.go
%{_libdir}/guile/2.2/site-ccache/fibers
%{_libdir}/guile/2.2/site-ccache/web/server/fibers.go
%{_datadir}/guile/site/2.2/fibers.scm
%{_datadir}/guile/site/2.2/fibers
%{_datadir}/guile/site/2.2/web/server/fibers.scm

%files -n guile30-%{srcname}
%license guile30/COPYING guile30/COPYING.LESSER
%doc guile30/README.md guile30/NEWS guile30/ChangeLog guile30/HACKING guile30/AUTHORS guile30/TODO.md
%{_libdir}/guile/3.0/extensions/fibers-epoll.so*
%{_libdir}/guile/3.0/site-ccache/fibers.go
%{_libdir}/guile/3.0/site-ccache/fibers
%{_libdir}/guile/3.0/site-ccache/web/server/fibers.go
%{_datadir}/guile/site/3.0/fibers.scm
%{_datadir}/guile/site/3.0/fibers
%{_datadir}/guile/site/3.0/web/server/fibers.scm

%files doc
%{_datadir}/info/fibers.info.gz
